## musl 0.9.14

=== Makefile ===
#
# Makefile for musl (requires GNU make)
#
# This is how simple every makefile should be...
# No, I take that back - actually most should be less than half this size.
#
# Use config.mak to override any of the following variables.
# Do not make changes here.
#

exec_prefix = /usr/local
bindir = $(exec_prefix)/bin

prefix = /usr/local/musl
includedir = $(prefix)/include
libdir = $(prefix)/lib
syslibdir = /lib

SRCS = $(sort $(wildcard src/*/*.c arch/$(ARCH)/src/*.c))
OBJS = $(SRCS:.c=.o)
LOBJS = $(OBJS:.o=.lo)
GENH = include/bits/alltypes.h
IMPH = src/internal/stdio_impl.h src/internal/pthread_impl.h src/internal/libc.h

LDFLAGS = 
LIBCC = -lgcc
CPPFLAGS =
CFLAGS = -Os -pipe
CFLAGS_C99FSE = -std=c99 -ffreestanding -nostdinc 

CFLAGS_ALL = $(CFLAGS_C99FSE)
CFLAGS_ALL += -D_XOPEN_SOURCE=700 -I./arch/$(ARCH) -I./src/internal -I./include
CFLAGS_ALL += $(CPPFLAGS) $(CFLAGS)
CFLAGS_ALL_STATIC = $(CFLAGS_ALL)
CFLAGS_ALL_SHARED = $(CFLAGS_ALL) -fPIC -DSHARED

AR      = $(CROSS_COMPILE)ar
RANLIB  = $(CROSS_COMPILE)ranlib
INSTALL = ./tools/install.sh

ARCH_INCLUDES = $(wildcard arch/$(ARCH)/bits/*.h)
ALL_INCLUDES = $(sort $(wildcard include/*.h include/*/*.h) $(GENH) $(ARCH_INCLUDES:arch/$(ARCH)/%=include/%))

EMPTY_LIB_NAMES = m rt pthread crypt util xnet resolv dl
EMPTY_LIBS = $(EMPTY_LIB_NAMES:%=lib/lib%.a)
CRT_LIBS = lib/crt1.o lib/Scrt1.o lib/crti.o lib/crtn.o
STATIC_LIBS = lib/libc.a
SHARED_LIBS = lib/libc.so
TOOL_LIBS = lib/musl-gcc.specs
ALL_LIBS = $(CRT_LIBS) $(STATIC_LIBS) $(SHARED_LIBS) $(EMPTY_LIBS) $(TOOL_LIBS)
ALL_TOOLS = tools/musl-gcc

LDSO_PATHNAME = $(syslibdir)/ld-musl-$(ARCH)$(SUBARCH).so.1

-include config.mak

all: $(ALL_LIBS) $(ALL_TOOLS)

install: install-libs install-headers install-tools

clean:
	rm -f crt/*.o
	rm -f $(OBJS)
	rm -f $(LOBJS)
	rm -f $(ALL_LIBS) lib/*.[ao] lib/*.so
	rm -f $(ALL_TOOLS)
	rm -f $(GENH) 
	rm -f include/bits

distclean: clean
	rm -f config.mak

include/bits:
	@test "$(ARCH)" || { echo "Please set ARCH in config.mak before running make." ; exit 1 ; }
	ln -sf ../arch/$(ARCH)/bits $@

include/bits/alltypes.h.in: include/bits

include/bits/alltypes.h: include/bits/alltypes.h.in include/alltypes.h.in tools/mkalltypes.sed
	sed -f tools/mkalltypes.sed include/bits/alltypes.h.in include/alltypes.h.in > $@

src/ldso/dynlink.lo: arch/$(ARCH)/reloc.h

crt/crt1.o crt/Scrt1.o: $(wildcard arch/$(ARCH)/crt_arch.h)

crt/Scrt1.o: CFLAGS += -fPIC

OPTIMIZE_SRCS = $(wildcard $(OPTIMIZE_GLOBS:%=src/%))
$(OPTIMIZE_SRCS:%.c=%.o) $(OPTIMIZE_SRCS:%.c=%.lo): CFLAGS += -O3

MEMOPS_SRCS = src/string/memcpy.c src/string/memmove.c src/string/memcmp.c src/string/memset.c
$(MEMOPS_SRCS:%.c=%.o) $(MEMOPS_SRCS:%.c=%.lo): CFLAGS += $(CFLAGS_MEMOPS)

# This incantation ensures that changes to any subarch asm files will
# force the corresponding object file to be rebuilt, even if the implicit
# rule below goes indirectly through a .sub file.
define mkasmdep
$(dir $(patsubst %/,%,$(dir $(1))))$(notdir $(1:.s=.o)): $(1)
endef
$(foreach s,$(wildcard src/*/$(ARCH)*/*.s),$(eval $(call mkasmdep,$(s))))

%.o: $(ARCH)$(ASMSUBARCH)/%.sub
	$(CC) $(CFLAGS_ALL_STATIC) -c -o $@ $(dir $<)$(shell cat $<)

%.o: $(ARCH)/%.s
	$(CC) $(CFLAGS_ALL_STATIC) -c -o $@ $<

%.o: %.c $(GENH) $(IMPH)
	$(CC) $(CFLAGS_ALL_STATIC) -c -o $@ $<

%.lo: $(ARCH)$(ASMSUBARCH)/%.sub
	$(CC) $(CFLAGS_ALL_SHARED) -c -o $@ $(dir $<)$(shell cat $<)

%.lo: $(ARCH)/%.s
	$(CC) $(CFLAGS_ALL_SHARED) -c -o $@ $<

%.lo: %.c $(GENH) $(IMPH)
	$(CC) $(CFLAGS_ALL_SHARED) -c -o $@ $<

lib/libc.so: $(LOBJS)
	$(CC) $(CFLAGS_ALL_SHARED) $(LDFLAGS) -nostdlib -shared \
	-Wl,-e,_start -Wl,-Bsymbolic-functions \
	-o $@ $(LOBJS) $(LIBCC)

lib/libc.a: $(OBJS)
	rm -f $@
	$(AR) rc $@ $(OBJS)
	$(RANLIB) $@

$(EMPTY_LIBS):
	rm -f $@
	$(AR) rc $@

lib/%.o: crt/%.o
	cp $< $@

lib/musl-gcc.specs: tools/musl-gcc.specs.sh config.mak
	sh $< "$(includedir)" "$(libdir)" "$(LDSO_PATHNAME)" > $@

tools/musl-gcc: config.mak
	printf '#!/bin/sh\nexec "$${REALGCC:-gcc}" "$$@" -specs "%s/musl-gcc.specs"\n' "$(libdir)" > $@
	chmod +x $@

$(DESTDIR)$(bindir)/%: tools/%
	$(INSTALL) -D $< $@

$(DESTDIR)$(libdir)/%.so: lib/%.so
	$(INSTALL) -D -m 755 $< $@

$(DESTDIR)$(libdir)/%: lib/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: arch/$(ARCH)/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/%: include/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(LDSO_PATHNAME): $(DESTDIR)$(libdir)/libc.so
	$(INSTALL) -D -l $(libdir)/libc.so $@ || true

install-libs: $(ALL_LIBS:lib/%=$(DESTDIR)$(libdir)/%) $(if $(SHARED_LIBS),$(DESTDIR)$(LDSO_PATHNAME),)

install-headers: $(ALL_INCLUDES:include/%=$(DESTDIR)$(includedir)/%)

install-tools: $(ALL_TOOLS:tools/%=$(DESTDIR)$(bindir)/%)



.PRECIOUS: $(CRT_LIBS:lib/%=crt/%)

.PHONY: all clean install install-libs install-headers install-tools

=== debian/changelog ===
musl (0.9.14-2ubuntu1) trusty; urgency=low

  * Stop musl-dev providing libc-dev (closes: #725376).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Oct 2013 18:23:49 -0700

musl (0.9.14-2) unstable; urgency=low

  * Make musl-tools depend on musl-dev (Closes: #725060)
  * Place each package in the correct section (Closes: #725148)

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 04 Oct 2013 21:45:54 +0200

musl (0.9.14-1) unstable; urgency=low

  * Import upstream version 0.9.14
  * Only build on fully supported architectures
  * Point to new homepage in control file (Closes: #724277)
  * Revorked debian/rules
  * Solved possible problem with postrm script (Closes: #724247)

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 27 Sep 2013 23:47:18 +0200

musl (0.9.13-3) unstable; urgency=low

  * Ready for Debian upload  (Closes: #713072) 
  * Respect user set CC
  * Reworked package according to feedback gven
    by Anton Gladky. See #721839 for reference.
  * Reworked debian/copyright file according to
    feedback given by Paul Richards Tagliamonte

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 20 Sep 2013 20:54:14 +0200

musl (0.9.13-2) unstable; urgency=low

  * Added preliminary manpages for ld-musl-config and musl-gcc

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 20 Sep 2013 19:20:33 +0200

musl (0.9.13-1) unstable; urgency=low

  * Import upstream version 0.9.13

 -- Kevin Bortis <pkgs@bortis.ch>  Sun, 01 Sep 2013 22:20:46 +0200

musl (0.9.12-2) unstable; urgency=low

  * Corrected lintian error "description-starts-with-package-name"
  * Corrected lintian warning "shared-lib-without-dependency-information" 

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 02 Aug 2013 15:22:17 +0200

musl (0.9.12-1) unstable; urgency=low

  * Import upstream version 0.9.12
  * New LDSO_PATHNAME for armhf (/etc/ld-musl-armhf.path)

 -- Kevin Bortis <pkgs@bortis.ch>  Mon, 29 Jul 2013 15:46:21 +0000

musl (0.9.11-1) unstable; urgency=low

  * Import upstream version 0.9.11

 -- Kevin Bortis <pkgs@bortis.ch>  Sun, 30 Jun 2013 18:16:00 +0200

musl (0.9.10-1) unstable; urgency=low

  * Initial release (Closes: #713072)

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 21 Jun 2013 17:12:20 +0200

=== debian/control ===
Source: musl
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kevin Bortis <pkgs@bortis.ch>
Build-Depends: debhelper (>=9), dh-exec (>=0.6)
Standards-Version: 3.9.4
Homepage: http://www.musl-libc.org/
Vcs-Git: https://github.com/wermut/musl.git
Vcs-Browser: https://github.com/wermut/musl/

Package: musl
Section: libs
Architecture: armel armhf i386 amd64 mips mipsel
Depends: ${misc:Depends}
Description: standard C library
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the shared objects

Package: musl-dev
Section: libdevel
Architecture: armel armhf i386 amd64 mips mipsel
Depends: ${misc:Depends}, musl (= ${binary:Version})
Description: standard C library development files
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the static linked libraries
 and the include files.

Package: musl-tools
Section: devel
Architecture: armel armhf i386 amd64 mips mipsel
Depends: ${misc:Depends}, musl-dev (= ${binary:Version}),
         gcc (>= 4.7.2)
Description: standard C library tools
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the gcc spec file and the
 musl-gcc wraper script to make easy-to-deploy static
 and minimally dynamic linked programs.

## musl 0.9.15

=== debian/changelog ===
musl (0.9.15-1) unstable; urgency=low

  * Import upstream version 0.9.15
  * Do no longer provide libc-dev (Closes: #725376)
  * Make runtime package multi-arch (Closes: #732170)

 -- Kevin Bortis <pkgs@bortis.ch>  Sun, 05 Jan 2014 20:11:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: musl
 Section: libs
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kevin Bortis <pkgs@bortis.ch>
+Maintainer: Kevin Bortis <pkgs@bortis.ch>
 Build-Depends: debhelper (>=9), dh-exec (>=0.6)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.musl-libc.org/
 Vcs-Git: https://github.com/wermut/musl.git
 Vcs-Browser: https://github.com/wermut/musl/
@@ -12,6 +11,7 @@
 Package: musl
 Section: libs
 Architecture: armel armhf i386 amd64 mips mipsel
+Multi-Arch: same
 Depends: ${misc:Depends}
 Description: standard C library
  musl is lightweight, fast, simple, free and strives

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Calculating musl based architecture
MUSL_ARCH=$(DEB_HOST_GNU_CPU)
MUSL_TRIPLE=$(DEB_HOST_GNU_CPU)-linux-musl

ifeq ($(DEB_HOST_ARCH),armel)
  MUSL_ARCH=arm
  MUSL_TRIPLE=arm-linux-musleabi
endif

ifeq ($(DEB_HOST_ARCH),armhf)
  MUSL_ARCH=armhf
  MUSL_TRIPLE=arm-linux-musleabihf
endif

ifeq ($(DEB_HOST_ARCH),i386)
  MUSL_ARCH=i386
  MUSL_TRIPLE=i386-linux-musl
endif
export MUSL_ARCH
export MUSL_TRIPLE

# Cross build support
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))  
  CC ?= cc
else
  CC=$(DEB_HOST_GNU_TYPE)-gcc
  CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
  export CROSS_COMPILE
endif
export CC

# Clear variables to make musl happy
CFLAGS=
CPPFLAGS=
LDFLAGS=
export CFLAGS
export CPPFLAGS
export LDFLAGS

%:
	dh $@ --parallel

debian/scripts/$(MUSL_TRIPLE).path: debian/scripts/config.path.in
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' $< > $@
	cp debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-$(MUSL_ARCH).path

debian/scripts/ld-musl-config: debian/scripts/ld-musl-config.in
	sed 's/@MUSL_ARCH@/$(MUSL_ARCH)/g' $< > $@
	chmod +x debian/scripts/ld-musl-config

override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-config
	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE)

override_dh_fixperms:
	dh_fixperms --exclude libc.so

## musl 1.1.4

=== debian/changelog ===
musl (1.1.4-1) unstable; urgency=low

  * Import upstream version 1.1.4. (Closes: #754758)
  * Fixes possible stack-based buffer overflow CVE-2014-3484 (Closes: #750815) 
  * Includes fix for build regression on armhf and armel

 -- Kevin Bortis <pkgs@bortis.ch>  Mon, 26 May 2014 22:45:52 +0200

musl (1.1.0-1) unstable; urgency=low

  [ Kevin Bortis ]
  * Import upstream version 1.1.0

  [ Anton Gladky ]
  * Add autopkgtest according to DEP-8

 -- Kevin Bortis <pkgs@bortis.ch>  Fri, 25 Apr 2014 19:49:40 +0000

musl (1.0.0-1) unstable; urgency=medium

  * Import upstream version 1.0.0
  * Provide musl-ldd (Closes: #732169)
  * Arch independent ld-musl-config (Closes: #739205)

 -- Kevin Bortis <pkgs@bortis.ch>  Sat, 22 Mar 2014 09:39:56 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: libs
 Priority: extra
 Maintainer: Kevin Bortis <pkgs@bortis.ch>
-Build-Depends: debhelper (>=9), dh-exec (>=0.6)
+Build-Depends: debhelper (>=9), dh-exec (>=0.6) 
 Standards-Version: 3.9.5
 Homepage: http://www.musl-libc.org/
 Vcs-Git: https://github.com/wermut/musl.git
 Vcs-Browser: https://github.com/wermut/musl/
+XS-Testsuite: autopkgtest
 
 Package: musl
 Section: libs

=== debian/watch ===
# See uscan(1) for format
version=3
http://www.musl-libc.org/releases/musl-(.*)\.tar\.gz

## musl 1.1.5

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 OBJS = $(SRCS:.c=.o)
 LOBJS = $(OBJS:.o=.lo)
 GENH = include/bits/alltypes.h
+GENH_INT = src/internal/version.h
 IMPH = src/internal/stdio_impl.h src/internal/pthread_impl.h src/internal/libc.h
 
 LDFLAGS = 
@@ -64,7 +65,7 @@
 	rm -f $(LOBJS)
 	rm -f $(ALL_LIBS) lib/*.[ao] lib/*.so
 	rm -f $(ALL_TOOLS)
-	rm -f $(GENH) 
+	rm -f $(GENH) $(GENH_INT)
 	rm -f include/bits
 
 distclean: clean
@@ -78,6 +79,11 @@
 
 include/bits/alltypes.h: include/bits/alltypes.h.in include/alltypes.h.in tools/mkalltypes.sed
 	sed -f tools/mkalltypes.sed include/bits/alltypes.h.in include/alltypes.h.in > $@
+
+src/internal/version.h: $(wildcard VERSION .git)
+	printf '#define VERSION "%s"\n' "$$(sh tools/version.sh)" > $@
+
+src/internal/version.lo: src/internal/version.h
 
 src/ldso/dynlink.lo: arch/$(ARCH)/reloc.h
 
@@ -119,7 +125,7 @@
 
 lib/libc.so: $(LOBJS)
 	$(CC) $(CFLAGS_ALL_SHARED) $(LDFLAGS) -nostdlib -shared \
-	-Wl,-e,_start -Wl,-Bsymbolic-functions \
+	-Wl,-e,_dlstart -Wl,-Bsymbolic-functions \
 	-o $@ $(LOBJS) $(LIBCC)
 
 lib/libc.a: $(OBJS)
@@ -165,7 +171,11 @@
 
 install-tools: $(ALL_TOOLS:tools/%=$(DESTDIR)$(bindir)/%)
 
+musl-git-%.tar.gz: .git
+	 git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ $(patsubst musl-git-%.tar.gz,%,$@)
 
+musl-%.tar.gz: .git
+	 git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ v$(patsubst musl-%.tar.gz,%,$@)
 
 .PRECIOUS: $(CRT_LIBS:lib/%=crt/%)

=== debian/changelog ===
musl (1.1.5-2) unstable; urgency=low

  * Fixes possible stack-based buffer overflow CVE-2015-1817 (Closes: #781497)

 -- Kevin Bortis <pkgs@bortis.ch>  Tue, 31 Mar 2015 22:42:17 +0200

musl (1.1.5-1) unstable; urgency=low

  [ Kevin Bortis ]
  * Import upstream version 1.1.5
  * New library-level C11 support

  [ Anton Gladky ]
  * Set Standards-Version: 3.9.6. No changes.

 -- Kevin Bortis <pkgs@bortis.ch>  Tue, 14 Oct 2014 21:13:35 +0200

=== debian/rules ===
--- 
+++ 
@@ -52,11 +52,7 @@
 	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' $< > $@
 	cp debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-$(MUSL_ARCH).path
 
-debian/scripts/ld-musl-config: debian/scripts/ld-musl-config.in
-	sed 's/@MUSL_ARCH@/$(MUSL_ARCH)/g' $< > $@
-	chmod +x debian/scripts/ld-musl-config
-
-override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-config
+override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path
 	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE)
 
 override_dh_fixperms:

## musl 1.1.9

=== Makefile ===
--- 
+++ 
@@ -85,9 +85,9 @@
 
 src/internal/version.lo: src/internal/version.h
 
-src/ldso/dynlink.lo: arch/$(ARCH)/reloc.h
+src/ldso/dlstart.lo src/ldso/dynlink.lo: src/internal/dynlink.h arch/$(ARCH)/reloc.h
 
-crt/crt1.o crt/Scrt1.o: $(wildcard arch/$(ARCH)/crt_arch.h)
+crt/crt1.o crt/Scrt1.o src/ldso/dlstart.lo: $(wildcard arch/$(ARCH)/crt_arch.h)
 
 crt/Scrt1.o: CFLAGS += -fPIC
 
@@ -96,6 +96,15 @@
 
 MEMOPS_SRCS = src/string/memcpy.c src/string/memmove.c src/string/memcmp.c src/string/memset.c
 $(MEMOPS_SRCS:%.c=%.o) $(MEMOPS_SRCS:%.c=%.lo): CFLAGS += $(CFLAGS_MEMOPS)
+
+NOSSP_SRCS = $(wildcard crt/*.c) \
+	src/env/__libc_start_main.c src/env/__init_tls.c \
+	src/thread/__set_thread_area.c src/env/__stack_chk_fail.c \
+	src/string/memset.c src/string/memcpy.c \
+	src/ldso/dlstart.c src/ldso/dynlink.c
+$(NOSSP_SRCS:%.c=%.o) $(NOSSP_SRCS:%.c=%.lo): CFLAGS += $(CFLAGS_NOSSP)
+
+$(CRT_LIBS): CFLAGS += -DCRT
 
 # This incantation ensures that changes to any subarch asm files will
 # force the corresponding object file to be rebuilt, even if the implicit

=== debian/changelog ===
musl (1.1.9-1) unstable; urgency=low

  [ Kevin Bortis ]
  * Import upstream version 1.1.9 
  * Provide linux-libc-dev on musl-linux-any
  
  [ Helmut Grohne ]
  * Build musl for the corresponding musl-linux-any (Closes: #783078)
  * Provide libc-dev on musl-linux-any

 -- Kevin Bortis <pkgs@bortis.ch>  Wed, 29 Apr 2015 18:16:36 +0200

musl (1.1.8-1~exp1) experimental; urgency=low

  * Import upstream version 1.1.8
  * Fixes possible stack-based buffer overflow CVE-2015-1817
  * Includes new aarch64 port

 -- Kevin Bortis <pkgs@bortis.ch>  Tue, 31 Mar 2015 19:49:20 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Kevin Bortis <pkgs@bortis.ch>
 Build-Depends: debhelper (>=9), dh-exec (>=0.6) 
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.musl-libc.org/
 Vcs-Git: https://github.com/wermut/musl.git
 Vcs-Browser: https://github.com/wermut/musl/
@@ -11,7 +11,7 @@
 
 Package: musl
 Section: libs
-Architecture: armel armhf i386 amd64 mips mipsel
+Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel
 Multi-Arch: same
 Depends: ${misc:Depends}
 Description: standard C library
@@ -23,8 +23,10 @@
 
 Package: musl-dev
 Section: libdevel
-Architecture: armel armhf i386 amd64 mips mipsel
-Depends: ${misc:Depends}, musl (= ${binary:Version})
+Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel
+Provides: ${libc-dev:Provides}
+Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
+Recommends: ${linux-musl-dev:Recommends}
 Description: standard C library development files
  musl is lightweight, fast, simple, free and strives
  to be correct in the sense of standards-conformance
@@ -35,7 +37,7 @@
 
 Package: musl-tools
 Section: devel
-Architecture: armel armhf i386 amd64 mips mipsel
+Architecture: arm64 armel armhf i386 amd64 mips mipsel
 Depends: ${misc:Depends}, musl-dev (= ${binary:Version}),
          gcc (>= 4.7.2)
 Description: standard C library tools

=== debian/rules ===
--- 
+++ 
@@ -4,23 +4,24 @@
 DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
+DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
 # Calculating musl based architecture
 MUSL_ARCH=$(DEB_HOST_GNU_CPU)
 MUSL_TRIPLE=$(DEB_HOST_GNU_CPU)-linux-musl
 
-ifeq ($(DEB_HOST_ARCH),armel)
+ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
   MUSL_ARCH=arm
   MUSL_TRIPLE=arm-linux-musleabi
 endif
 
-ifeq ($(DEB_HOST_ARCH),armhf)
+ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
   MUSL_ARCH=armhf
   MUSL_TRIPLE=arm-linux-musleabihf
 endif
 
-ifeq ($(DEB_HOST_ARCH),i386)
+ifeq ($(DEB_HOST_ARCH_CPU),i386)
   MUSL_ARCH=i386
   MUSL_TRIPLE=i386-linux-musl
 endif
@@ -45,6 +46,14 @@
 export CPPFLAGS
 export LDFLAGS
 
+# Substitue control file variables debending on the debian libc type
+# If musl is the native libc, we can provide libc and depend on linux-libc-dev
+ifneq (,$(findstring musl-linux-,$(DEB_HOST_ARCH)))
+  GENCTRL_OPTIONS = -Vlibc-dev:Provides=libc-dev -Vlinux-libc-dev:Depends=linux-libc-dev 
+else
+  GENCTRL_OPTIONS = -Vlinux-musl-dev:Recommends=linux-musl-dev
+endif
+
 %:
 	dh $@ --parallel
 
@@ -58,3 +67,5 @@
 override_dh_fixperms:
 	dh_fixperms --exclude libc.so
 
+override_dh_gencontrol:
+	dh_gencontrol -- $(GENCTRL_OPTIONS)

## musl 1.1.15

=== debian/changelog ===
musl (1.1.15-2) unstable; urgency=high

  * Cherry-pick upstream fix for regex integer overflow in buffer size
    computations; CVE-2016-8859 (Closes: #842171)

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 27 Oct 2016 18:53:49 +0200

musl (1.1.15-1) unstable; urgency=low

  * New upstream release.
  * New supported architectures: mips64el, sh4
  * debian/control:
    - Adopt package, update maintainer. (Closes: #830176)
    - Remove unneeded XS-Testsuite field
    - Change Vcs-* fields to point to collab-maint.
    - Bump Standards-Version to 3.9.8.
  * Add upstream's signing key.
  * Check PGP signature when importing upstream releases.
  * Move musl-ldd symlink from musl to musl-tools. (Closes: #803577)
  * Drop ARM thumb compatibility patch (applied upstream).
  * Install upstream changelog.
  * postinst/postrm: Set -e in body instead of shebang.
  * Fix manpage typos found by lintian.
  * Remove duplicate mdoc manpages.
  * Build with debugging symbols to support dbgsym packages.
  * Update copyrights; remove trailing whitespace.
  * Amend autopkgtest to test dynamic linking.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 08 Jul 2016 14:38:17 +0200

musl (1.1.9-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Always enable gcc wrapper, as it is no longer required for gcc6,
    but is still useful for older gcc versions. (Closes: #812278)

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 06 Jul 2016 21:07:23 +0200

musl (1.1.9-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Create /usr/lib/$MUSL_TRIPLE/libc.so in postinst to support merged /usr
    systems. (Closes: #766812)

 -- Marco d'Itri <md@linux.it>  Sat, 06 Feb 2016 01:12:33 +0100

=== debian/control ===
Source: musl
Section: libs
Priority: extra
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper (>= 9), dh-exec (>= 0.6)
Standards-Version: 3.9.8
Homepage: http://www.musl-libc.org/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/musl.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/musl.git

Package: musl
Section: libs
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el sh4 musl-linux-sh4
Multi-Arch: same
Depends: ${misc:Depends}
Description: standard C library
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the shared objects

Package: musl-dev
Section: libdevel
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el sh4 musl-linux-sh4
Provides: ${libc-dev:Provides}
Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
Recommends: ${linux-musl-dev:Recommends}
Description: standard C library development files
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the static linked libraries
 and the include files.

Package: musl-tools
Section: devel
Architecture: arm64 armel armhf i386 amd64 mips mipsel mips64el sh4
Depends: ${misc:Depends}, musl-dev (= ${binary:Version}),
         gcc (>= 4.7.2)
Replaces: musl (<< 1.1.15-1)
Breaks: musl (<< 1.1.15-1)
Description: standard C library tools
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the gcc spec file and the
 musl-gcc wrapper script to make easy-to-deploy static
 and minimal dynamically linked programs.

=== debian/rules ===
--- 
+++ 
@@ -62,10 +62,24 @@
 	cp debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-$(MUSL_ARCH).path
 
 override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path
-	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE)
+	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE) --enable-gcc-wrapper --enable-debug
 
 override_dh_fixperms:
 	dh_fixperms --exclude libc.so
 
 override_dh_gencontrol:
 	dh_gencontrol -- $(GENCTRL_OPTIONS)
+
+override_dh_clean:
+	rm -f debian/musl-dev.postinst debian/musl-dev.postrm
+	dh_clean
+
+override_dh_installdeb:
+	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
+		debian/musl-dev.postinst.in > debian/musl-dev.postinst
+	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
+		debian/musl-dev.postrm.in > debian/musl-dev.postrm
+	dh_installdeb
+
+override_dh_installchangelogs:
+	dh_installchangelogs WHATSNEW

## musl 1.1.16

=== debian/changelog ===
musl (1.1.16-3) unstable; urgency=medium

  * Import upstream fix for PPC64 crash.
    Thanks to Breno Leitao for investigating. (Closes: #857078)

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 09 Mar 2017 19:19:31 +0100

musl (1.1.16-2) unstable; urgency=medium

  [ Breno Leitao ]
  * Enable building on ppc64el. (Closes: #851686)

  [ Reiner Herrmann ]
  * Fix build failure on armhf with newer binutils. (Closes: #852214)

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 22 Jan 2017 18:18:26 +0100

musl (1.1.16-1) unstable; urgency=low

  * New upstream release.
  * New supported architecture: s390x
  * Remove patch cve-2016-8859.diff (applied upstream).
  * Bump debhelper compatibility to 10.
    - drop --parallel, which is now default.
  * Use Debian buildflags and enable all hardening options.
  * Remove ancient version restrictions on gcc and dh-exec.
  * Disable PIE linking in musl-gcc wrapper to workaround linking issues
    (Closes: #847776).

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 03 Jan 2017 22:38:49 +0100

=== debian/control ===
Source: musl
Section: libs
Priority: extra
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper (>= 10), dh-exec
Standards-Version: 3.9.8
Homepage: http://www.musl-libc.org/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/musl.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/musl.git

Package: musl
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
Multi-Arch: same
Depends: ${misc:Depends}
Description: standard C library
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the shared objects

Package: musl-dev
Section: libdevel
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
Provides: ${libc-dev:Provides}
Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
Recommends: ${linux-musl-dev:Recommends}
Description: standard C library development files
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the static linked libraries
 and the include files.

Package: musl-tools
Section: devel
Architecture: arm64 armel armhf i386 amd64 mips mipsel mips64el s390x sh4 ppc64el
Depends: ${misc:Depends}, musl-dev (= ${binary:Version}), gcc, libdpkg-perl (>= 1.18.11)
Replaces: musl (<< 1.1.15-1)
Breaks: musl (<< 1.1.15-1)
Description: standard C library tools
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the gcc spec file and the
 musl-gcc wrapper script to make easy-to-deploy static
 and minimal dynamically linked programs.

=== debian/rules ===
--- 
+++ 
@@ -25,11 +25,16 @@
   MUSL_ARCH=i386
   MUSL_TRIPLE=i386-linux-musl
 endif
+
+ifneq (,$(findstring ppc64el,$(DEB_HOST_ARCH)))
+  export DEB_CFLAGS_MAINT_APPEND += -mlong-double-64
+endif
+
 export MUSL_ARCH
 export MUSL_TRIPLE
 
 # Cross build support
-ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))  
+ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
   CC ?= cc
 else
   CC=$(DEB_HOST_GNU_TYPE)-gcc
@@ -38,13 +43,7 @@
 endif
 export CC
 
-# Clear variables to make musl happy
-CFLAGS=
-CPPFLAGS=
-LDFLAGS=
-export CFLAGS
-export CPPFLAGS
-export LDFLAGS
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # Substitue control file variables debending on the debian libc type
 # If musl is the native libc, we can provide libc and depend on linux-libc-dev
@@ -55,7 +54,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 debian/scripts/$(MUSL_TRIPLE).path: debian/scripts/config.path.in
 	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' $< > $@

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
 http://www.musl-libc.org/releases/musl-([\d\.]+)\.tar\.gz

## musl 1.1.18

=== debian/changelog ===
musl (1.1.18-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch applied upstream.
  * Remove trailing whitespace in d/changelog and d/rules.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 31 Oct 2017 21:57:13 +0100

musl (1.1.17-2) unstable; urgency=medium

  * Fix build failure on armel because of unsupported instruction.
    Thanks to Adrian Bunk for providing the patch. (Closes: #879190)

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 20 Oct 2017 18:19:33 +0200

musl (1.1.17-1) unstable; urgency=high

  * New upstream release.
    - Fixes security issue: buffer overflow in dns response parsing
      (CVE-2017-15650)
  * Drop patches applied upstream.
  * Update Standards-Version to 4.1.1.
    - change priority to optional
  * Switch http URLs to https.
  * Bump copyright years for 2017.
  * Mark musl-dev as Multi-Arch: same (Closes: #873363)
    - add lintian override for musl-specific directory unknown to lintian

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 19 Oct 2017 23:08:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: musl
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
 Build-Depends: debhelper (>= 10), dh-exec
-Standards-Version: 3.9.8
-Homepage: http://www.musl-libc.org/
+Standards-Version: 4.1.1
+Homepage: https://www.musl-libc.org/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/musl.git
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/musl.git
 
@@ -22,6 +22,7 @@
 Package: musl-dev
 Section: libdevel
 Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
+Multi-Arch: same
 Provides: ${libc-dev:Provides}
 Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
 Recommends: ${linux-musl-dev:Recommends}

## musl 1.1.19

=== Makefile ===
#
# Makefile for musl (requires GNU make)
#
# This is how simple every makefile should be...
# No, I take that back - actually most should be less than half this size.
#
# Use config.mak to override any of the following variables.
# Do not make changes here.
#

srcdir = .
exec_prefix = /usr/local
bindir = $(exec_prefix)/bin

prefix = /usr/local/musl
includedir = $(prefix)/include
libdir = $(prefix)/lib
syslibdir = /lib

SRC_DIRS = $(addprefix $(srcdir)/,src/* crt ldso)
BASE_GLOBS = $(addsuffix /*.c,$(SRC_DIRS))
ARCH_GLOBS = $(addsuffix /$(ARCH)/*.[csS],$(SRC_DIRS))
BASE_SRCS = $(sort $(wildcard $(BASE_GLOBS)))
ARCH_SRCS = $(sort $(wildcard $(ARCH_GLOBS)))
BASE_OBJS = $(patsubst $(srcdir)/%,%.o,$(basename $(BASE_SRCS)))
ARCH_OBJS = $(patsubst $(srcdir)/%,%.o,$(basename $(ARCH_SRCS)))
REPLACED_OBJS = $(sort $(subst /$(ARCH)/,/,$(ARCH_OBJS)))
ALL_OBJS = $(addprefix obj/, $(filter-out $(REPLACED_OBJS), $(sort $(BASE_OBJS) $(ARCH_OBJS))))

LIBC_OBJS = $(filter obj/src/%,$(ALL_OBJS))
LDSO_OBJS = $(filter obj/ldso/%,$(ALL_OBJS:%.o=%.lo))
CRT_OBJS = $(filter obj/crt/%,$(ALL_OBJS))

AOBJS = $(LIBC_OBJS)
LOBJS = $(LIBC_OBJS:.o=.lo)
GENH = obj/include/bits/alltypes.h obj/include/bits/syscall.h
GENH_INT = obj/src/internal/version.h
IMPH = $(addprefix $(srcdir)/, src/internal/stdio_impl.h src/internal/pthread_impl.h src/internal/locale_impl.h src/internal/libc.h)

LDFLAGS =
LDFLAGS_AUTO =
LIBCC = -lgcc
CPPFLAGS =
CFLAGS =
CFLAGS_AUTO = -Os -pipe
CFLAGS_C99FSE = -std=c99 -ffreestanding -nostdinc 

CFLAGS_ALL = $(CFLAGS_C99FSE)
CFLAGS_ALL += -D_XOPEN_SOURCE=700 -I$(srcdir)/arch/$(ARCH) -I$(srcdir)/arch/generic -Iobj/src/internal -I$(srcdir)/src/internal -Iobj/include -I$(srcdir)/include
CFLAGS_ALL += $(CPPFLAGS) $(CFLAGS_AUTO) $(CFLAGS)

LDFLAGS_ALL = $(LDFLAGS_AUTO) $(LDFLAGS)

AR      = $(CROSS_COMPILE)ar
RANLIB  = $(CROSS_COMPILE)ranlib
INSTALL = $(srcdir)/tools/install.sh

ARCH_INCLUDES = $(wildcard $(srcdir)/arch/$(ARCH)/bits/*.h)
GENERIC_INCLUDES = $(wildcard $(srcdir)/arch/generic/bits/*.h)
INCLUDES = $(wildcard $(srcdir)/include/*.h $(srcdir)/include/*/*.h)
ALL_INCLUDES = $(sort $(INCLUDES:$(srcdir)/%=%) $(GENH:obj/%=%) $(ARCH_INCLUDES:$(srcdir)/arch/$(ARCH)/%=include/%) $(GENERIC_INCLUDES:$(srcdir)/arch/generic/%=include/%))

EMPTY_LIB_NAMES = m rt pthread crypt util xnet resolv dl
EMPTY_LIBS = $(EMPTY_LIB_NAMES:%=lib/lib%.a)
CRT_LIBS = $(addprefix lib/,$(notdir $(CRT_OBJS)))
STATIC_LIBS = lib/libc.a
SHARED_LIBS = lib/libc.so
TOOL_LIBS = lib/musl-gcc.specs
ALL_LIBS = $(CRT_LIBS) $(STATIC_LIBS) $(SHARED_LIBS) $(EMPTY_LIBS) $(TOOL_LIBS)
ALL_TOOLS = obj/musl-gcc

WRAPCC_GCC = gcc
WRAPCC_CLANG = clang

LDSO_PATHNAME = $(syslibdir)/ld-musl-$(ARCH)$(SUBARCH).so.1

-include config.mak

ifeq ($(ARCH),)

all:
	@echo "Please set ARCH in config.mak before running make."
	@exit 1

else

all: $(ALL_LIBS) $(ALL_TOOLS)

OBJ_DIRS = $(sort $(patsubst %/,%,$(dir $(ALL_LIBS) $(ALL_TOOLS) $(ALL_OBJS) $(GENH) $(GENH_INT))) obj/include)

$(ALL_LIBS) $(ALL_TOOLS) $(ALL_OBJS) $(ALL_OBJS:%.o=%.lo) $(GENH) $(GENH_INT): | $(OBJ_DIRS)

$(OBJ_DIRS):
	mkdir -p $@

obj/include/bits/alltypes.h: $(srcdir)/arch/$(ARCH)/bits/alltypes.h.in $(srcdir)/include/alltypes.h.in $(srcdir)/tools/mkalltypes.sed
	sed -f $(srcdir)/tools/mkalltypes.sed $(srcdir)/arch/$(ARCH)/bits/alltypes.h.in $(srcdir)/include/alltypes.h.in > $@

obj/include/bits/syscall.h: $(srcdir)/arch/$(ARCH)/bits/syscall.h.in
	cp $< $@
	sed -n -e s/__NR_/SYS_/p < $< >> $@

obj/src/internal/version.h: $(wildcard $(srcdir)/VERSION $(srcdir)/.git)
	printf '#define VERSION "%s"\n' "$$(cd $(srcdir); sh tools/version.sh)" > $@

obj/src/internal/version.o obj/src/internal/version.lo: obj/src/internal/version.h

obj/crt/rcrt1.o obj/ldso/dlstart.lo obj/ldso/dynlink.lo: $(srcdir)/src/internal/dynlink.h $(srcdir)/arch/$(ARCH)/reloc.h

obj/crt/crt1.o obj/crt/scrt1.o obj/crt/rcrt1.o obj/ldso/dlstart.lo: $(srcdir)/arch/$(ARCH)/crt_arch.h

obj/crt/rcrt1.o: $(srcdir)/ldso/dlstart.c

obj/crt/Scrt1.o obj/crt/rcrt1.o: CFLAGS_ALL += -fPIC

OPTIMIZE_SRCS = $(wildcard $(OPTIMIZE_GLOBS:%=$(srcdir)/src/%))
$(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.o) $(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.lo): CFLAGS += -O3

MEMOPS_SRCS = src/string/memcpy.c src/string/memmove.c src/string/memcmp.c src/string/memset.c
$(MEMOPS_SRCS:%.c=obj/%.o) $(MEMOPS_SRCS:%.c=obj/%.lo): CFLAGS_ALL += $(CFLAGS_MEMOPS)

NOSSP_SRCS = $(wildcard crt/*.c) \
	src/env/__libc_start_main.c src/env/__init_tls.c \
	src/env/__stack_chk_fail.c \
	src/thread/__set_thread_area.c src/thread/$(ARCH)/__set_thread_area.c \
	src/string/memset.c src/string/$(ARCH)/memset.c \
	src/string/memcpy.c src/string/$(ARCH)/memcpy.c \
	ldso/dlstart.c ldso/dynlink.c
$(NOSSP_SRCS:%.c=obj/%.o) $(NOSSP_SRCS:%.c=obj/%.lo): CFLAGS_ALL += $(CFLAGS_NOSSP)

$(CRT_OBJS): CFLAGS_ALL += -DCRT

$(LOBJS) $(LDSO_OBJS): CFLAGS_ALL += -fPIC

CC_CMD = $(CC) $(CFLAGS_ALL) -c -o $@ $<

# Choose invocation of assembler to be used
ifeq ($(ADD_CFI),yes)
	AS_CMD = LC_ALL=C awk -f $(srcdir)/tools/add-cfi.common.awk -f $(srcdir)/tools/add-cfi.$(ARCH).awk $< | $(CC) $(CFLAGS_ALL) -x assembler -c -o $@ -
else
	AS_CMD = $(CC_CMD)
endif

obj/%.o: $(srcdir)/%.s
	$(AS_CMD)

obj/%.o: $(srcdir)/%.S
	$(CC_CMD)

obj/%.o: $(srcdir)/%.c $(GENH) $(IMPH)
	$(CC_CMD)

obj/%.lo: $(srcdir)/%.s
	$(AS_CMD)

obj/%.lo: $(srcdir)/%.S
	$(CC_CMD)

obj/%.lo: $(srcdir)/%.c $(GENH) $(IMPH)
	$(CC_CMD)

lib/libc.so: $(LOBJS) $(LDSO_OBJS)
	$(CC) $(CFLAGS_ALL) $(LDFLAGS_ALL) -nostdlib -shared \
	-Wl,-e,_dlstart -o $@ $(LOBJS) $(LDSO_OBJS) $(LIBCC)

lib/libc.a: $(AOBJS)
	rm -f $@
	$(AR) rc $@ $(AOBJS)
	$(RANLIB) $@

$(EMPTY_LIBS):
	rm -f $@
	$(AR) rc $@

lib/%.o: obj/crt/$(ARCH)/%.o
	cp $< $@

lib/%.o: obj/crt/%.o
	cp $< $@

lib/musl-gcc.specs: $(srcdir)/tools/musl-gcc.specs.sh config.mak
	sh $< "$(includedir)" "$(libdir)" "$(LDSO_PATHNAME)" > $@

obj/musl-gcc: config.mak
	printf '#!/bin/sh\nexec "$${REALGCC:-$(WRAPCC_GCC)}" "$$@" -specs "%s/musl-gcc.specs"\n' "$(libdir)" > $@
	chmod +x $@

obj/%-clang: $(srcdir)/tools/%-clang.in config.mak
	sed -e 's!@CC@!$(WRAPCC_CLANG)!g' -e 's!@PREFIX@!$(prefix)!g' -e 's!@INCDIR@!$(includedir)!g' -e 's!@LIBDIR@!$(libdir)!g' -e 's!@LDSO@!$(LDSO_PATHNAME)!g' $< > $@
	chmod +x $@

$(DESTDIR)$(bindir)/%: obj/%
	$(INSTALL) -D $< $@

$(DESTDIR)$(libdir)/%.so: lib/%.so
	$(INSTALL) -D -m 755 $< $@

$(DESTDIR)$(libdir)/%: lib/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: $(srcdir)/arch/$(ARCH)/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: $(srcdir)/arch/generic/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: obj/include/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/%: $(srcdir)/include/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(LDSO_PATHNAME): $(DESTDIR)$(libdir)/libc.so
	$(INSTALL) -D -l $(libdir)/libc.so $@ || true

install-libs: $(ALL_LIBS:lib/%=$(DESTDIR)$(libdir)/%) $(if $(SHARED_LIBS),$(DESTDIR)$(LDSO_PATHNAME),)

install-headers: $(ALL_INCLUDES:include/%=$(DESTDIR)$(includedir)/%)

install-tools: $(ALL_TOOLS:obj/%=$(DESTDIR)$(bindir)/%)

install: install-libs install-headers install-tools

musl-git-%.tar.gz: .git
	 git --git-dir=$(srcdir)/.git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ $(patsubst musl-git-%.tar.gz,%,$@)

musl-%.tar.gz: .git
	 git --git-dir=$(srcdir)/.git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ v$(patsubst musl-%.tar.gz,%,$@)

endif

clean:
	rm -rf obj lib

distclean: clean
	rm -f config.mak

.PHONY: all clean install install-libs install-headers install-tools

=== debian/changelog ===
musl (1.1.19-1) unstable; urgency=medium

  * New upstream release.
  * Move packaging VCS to salsa.
  * Bump Standards-Version to 4.1.3.
  * Bump debhelper compat/dependency to 11.
  * Fix spelling error found by lintian.
  * Override lintian warning application-in-library-section for musl.
  * Add upstream metadata file.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 25 Feb 2018 18:54:30 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
-Build-Depends: debhelper (>= 10), dh-exec
-Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 11), dh-exec
+Standards-Version: 4.1.3
 Homepage: https://www.musl-libc.org/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/musl.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/musl.git
+Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
+Vcs-Browser: https://salsa.debian.org/deki-guest/musl
 
 Package: musl
 Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el

=== debian/tests/control ===
Tests: build
Depends: musl-tools, build-essential

## musl 1.1.20

=== Makefile ===
--- 
+++ 
@@ -116,17 +116,14 @@
 OPTIMIZE_SRCS = $(wildcard $(OPTIMIZE_GLOBS:%=$(srcdir)/src/%))
 $(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.o) $(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.lo): CFLAGS += -O3
 
-MEMOPS_SRCS = src/string/memcpy.c src/string/memmove.c src/string/memcmp.c src/string/memset.c
-$(MEMOPS_SRCS:%.c=obj/%.o) $(MEMOPS_SRCS:%.c=obj/%.lo): CFLAGS_ALL += $(CFLAGS_MEMOPS)
-
-NOSSP_SRCS = $(wildcard crt/*.c) \
-	src/env/__libc_start_main.c src/env/__init_tls.c \
-	src/env/__stack_chk_fail.c \
-	src/thread/__set_thread_area.c src/thread/$(ARCH)/__set_thread_area.c \
-	src/string/memset.c src/string/$(ARCH)/memset.c \
-	src/string/memcpy.c src/string/$(ARCH)/memcpy.c \
-	ldso/dlstart.c ldso/dynlink.c
-$(NOSSP_SRCS:%.c=obj/%.o) $(NOSSP_SRCS:%.c=obj/%.lo): CFLAGS_ALL += $(CFLAGS_NOSSP)
+MEMOPS_OBJS = $(filter %/memcpy.o %/memmove.o %/memcmp.o %/memset.o, $(LIBC_OBJS))
+$(MEMOPS_OBJS) $(MEMOPS_OBJS:%.o=%.lo): CFLAGS_ALL += $(CFLAGS_MEMOPS)
+
+NOSSP_OBJS = $(CRT_OBJS) $(LDSO_OBJS) $(filter \
+	%/__libc_start_main.o %/__init_tls.o %/__stack_chk_fail.o \
+	%/__set_thread_area.o %/memset.o %/memcpy.o \
+	, $(LIBC_OBJS))
+$(NOSSP_OBJS) $(NOSSP_OBJS:%.o=%.lo): CFLAGS_ALL += $(CFLAGS_NOSSP)
 
 $(CRT_OBJS): CFLAGS_ALL += -DCRT

=== debian/changelog ===
musl (1.1.20-1) unstable; urgency=medium

  * New upstream release.
  * New supported architecture: m68k
  * Bump Standards-Version to 4.2.1.
  * Drop patch for working around binutils static linking bug.
    binutils fix is included in 2.31.1-2 (with a follow up in 2.31.1-3).
  * Drop patch with musl-gcc workaround for linking with default-pie
    toolchains, as the upstream specs file now includes a better solution.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 04 Sep 2018 22:31:55 +0200

musl (1.1.19-2) unstable; urgency=medium

  * Workaround binutils 2.31 bug that broke static linking.
    Thanks to Szabolcs Nagy for the analysis and workaround.
  * Bump Standards-Version to 4.1.5.
  * Add binutils to test dependencies to trigger autopkgtest runs when
    they are updated.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 19 Jul 2018 18:52:03 +0200

=== debian/control ===
Source: musl
Section: libs
Priority: optional
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper (>= 11), dh-exec
Standards-Version: 4.2.1
Homepage: https://www.musl-libc.org/
Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
Vcs-Browser: https://salsa.debian.org/deki-guest/musl

Package: musl
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
Multi-Arch: same
Depends: ${misc:Depends}
Description: standard C library
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the shared objects

Package: musl-dev
Section: libdevel
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
Multi-Arch: same
Provides: ${libc-dev:Provides}
Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
Recommends: ${linux-musl-dev:Recommends}
Description: standard C library development files
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the static linked libraries
 and the include files.

Package: musl-tools
Section: devel
Architecture: arm64 armel armhf i386 amd64 m68k mips mipsel mips64el s390x sh4 ppc64el
Depends: ${misc:Depends}, musl-dev (= ${binary:Version}), gcc
Replaces: musl (<< 1.1.15-1)
Breaks: musl (<< 1.1.15-1)
Description: standard C library tools
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the gcc spec file and the
 musl-gcc wrapper script to make easy-to-deploy static
 and minimal dynamically linked programs.

=== debian/tests/control ===
Tests: build
Depends: musl-tools, binutils, build-essential

## musl 1.1.21

=== debian/changelog ===
musl (1.1.21-2) unstable; urgency=medium

  * Revert "Install ld.so symlink with dh_install instead of dh_link".
    The upstream symlink was pointing to /usr/lib/${TRIPLE}/libc.so, which
    is part of a different package (musl-dev).
  * Add /lib/ld-musl-*.so.1 symlink to debian/not-installed, to tell
    dh_missing that it is deliberately not installed.

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 23 Jan 2019 20:32:39 +0100

musl (1.1.21-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0.
  * Depend on debhelper-compat and bump compat level to 12.
  * Install ld.so symlink with dh_install instead of dh_link.
    dh_missing was confused by symlink that was also installed by
    upstream Makefile.
  * Declare that debian/rules does not require root.
  * Update debian/copyright and bump years.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 22 Jan 2019 20:23:18 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: libs
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
-Build-Depends: debhelper (>= 11), dh-exec
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12), dh-exec
+Standards-Version: 4.3.0
 Homepage: https://www.musl-libc.org/
 Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
 Vcs-Browser: https://salsa.debian.org/deki-guest/musl
+Rules-Requires-Root: no
 
 Package: musl
 Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el
